function [x,p]=gclss(A,b,p) 
% customized LinearSystemSolver for acgc. 
% To solve: Ax-lam<x>=b 
% With <x>=[triangle area]*C*x write (A-lam*nu eta)x=b 
% and solve by Sherman-Morrison
global lam eta nu; % lam set in acgcG
%fprintf('lam-lamo=%g\n',lam-p.u(p.nu+1));
y=A\b; z=A\nu; al0=lam*eta*z; al=lam*eta*y/(1-al0);
x=y+al*z; return % comment out to check Sherman-Morrison formula
c1=(A-lam*p.nu*p.eta)*x; c2=(A-lam*p.nu*p.eta)*y; 
err1=norm(c1-b); err2=norm(c2-b); 
fprintf('lss: |b|=%g, |x|=%g, |y|=%g, SM-err=%g, noSM-err=%g\n',...
    norm(b),norm(x),norm(y),err1,err2); %pause 