close all; keep pphome; % command templates for ql-AC; run cell-by-cell; 
%% 1D init 
par=[1; 0; 1; -0.8; 0.5];  % c0, lam, ga, del, epsi 
p=[]; lx=5; nx=80; dim=1; p=acinit(p,lx,nx,par,dim); screenlayout(p); 
p=setfn(p,'1D'); p=findbif(p,1); p=cont(p,10); % find 1st bifpoint 
%% BP1, bifurcate in both direction 
p=swibra('1D','bpt1','1D1a',0.1); p.nc.dsmax=0.2; p=cont(p,15); 
p=swibra('1D','bpt1','1D1b',-0.1); p=cont(p,15); 
%% BP2, just one direction cause symmetric
p=swibra('1D','bpt2','1D2',0.1); p.nc.dsmax=0.2; p=cont(p,25); 
%% BD plot
figure(3); clf; pcmp=0; 
plotbra('1D',3,pcmp,'cl','b'); 
plotbraf('1D1a',3,pcmp,'cl','k','lab',10,'fancy',0); 
plotbraf('1D1b',3,pcmp,'cl','k','lab',11,'fancy',0); 
plotbraf('1D2',3,pcmp,'cl','r','lab',20); 
%axis([-0.2 1 0 3.1]); xlabel('\lambda'); 
%% soln plot 
plotsol('1D1a','pt10'); pause; plotsol('1D1b','pt10'); pause; 
plotsol('1D2','pt20'); axis([-5 5  -0.8 1.35]); 
%% fold-cont 
p=spcontini('1D1b','fpt1',3,'b1f');   % init fold continuation with par 3 new primary par
p.plot.bpcmp=p.nc.ilam(2); figure(2); clf; % use this new parameter for plotting
p.sol.ds=-0.01; p.nc.tol=1e-8; p.sw.spjac=1; p.fuha.spjac=@spjac; % spectral jac
p.nc.del=1e-6; spjaccheck(p); pause 
p.usrlam=[]; p.sw.bifcheck=0; tic; p=cont(p,10); toc
%% switch back to regular continuation from one of the fold points
p=spcontexit('b1f','pt10','b1-a'); clf(2); p.sw.spcalc=1; 
p.nc.dsmax=0.5; p.sw.bifcheck=0;  p.plot.bpcmp=0; 
p.sol.ds=-1e-3; p=cont(p,1); p=cont(p,10); % continue in one direction 
p=loadp('b1-a','pt1','b1-b'); p.sol.ds=-p.sol.ds; % and the other one 
p.plot.bpcmp=0; p=cont(p,10); 