% command templates for Schnakenberg on a small domain; run cell-by-cell;
clear all; p=[]; spx=1; spy=1; nx=30; % 1 spot in x and 1 spot in y direction 
par=[sqrt(60)*sqrt(3-sqrt(8))+0.1, 0, 60]; p=ooschnakinit(p,[spx,spy],nx,par); 
p.sw.para=2; p.nc.dsmax=0.1; p.sol.ds=-0.1; p.nc.resfac=1e-3; p.nc.neig=30; 
p.nc.nsteps=50; p=setfn(p,'hom'); p.sw.bifcheck=2; p=cont(p,30);
%% h+
p=mswibra('hom','bpt1','h+',0.01); p=taugen(p,[1 -1]);
p=pmcont(p,1); p.pm.resfac=1e-4;  p.nc.dsmax=0.1;  
p=pmcont(p,10); %p=meshadac(p,'ngen',1); 
p.sol.ds=0.1; p.nc.dsmin=0.1; p.sw.bifcheck=1; p=pmcont(p,30); 
%% h-
p=loadp('h+','pt1','h-'); p.sol.ds=-0.05; p=resetc(p); p.sw.foldcheck=1; p=pmcont(p,30); 
%% s+ 
p=mswibra('hom','bpt1','s+',-0.01); p.file.smod=5;
p=taugen(p,[0 1]); p.nc.dsmax=0.1; p=pmcont(p,50);
% s-
p=mswibra('hom','bpt1','s-',0.01); p.file.smod=5;
p=taugen(p,[0 1]); p.nc.dsmax=0.1; p=pmcont(p,50);
%% b+ 
p=swibra('s+','bpt2','b+',0.05); p.nc.dsmin=0.05; p.pm.resfac=1e-3; p.file.smod=5; p=pmcont(p,20);
%% b- 
p=swibra('s-','bpt1','b-',0.05); p.nc.dsmin=0.05; p.pm.resfac=1e-3; p.file.smod=5; p=pmcont(p,10);
%% HOPF 
aux=[]; %aux.dlam=0; 
aux.tl=20; p=hoswibra('h-','hpt1',0.05,4,'ho1',aux); 
p.sw.verb=2; p.nc.tol=1e-6; p.hopf.flcheck=0; p.file.smod=5; 
p.vol= 220.1035; 
AMG=0; p.sw.verb=3;  % set AMG=1 if ilupack available
if ~AMG; p=setbel(p,1,1e-3,10,@lss); % use BEL without ilupack 
else p=setilup(p,1e-3,100); p.fuha.lss=@lss; p.fuha.blss=@lssAMG; 
     % no bel on this one, cause ilupack seems indifferent to borders! 
end 
p.nc.dsmax=300; p.branch=[]; p.fuha.outfu=@hobra; p=cont(p,50); 
%% plot BD 
fnr=3; figure(fnr); clf; 
plotbraf('hom','pt30',fnr,4,'cl','k');
plotbra('s+','pt50',fnr,4,'cl','b','lab',35); 
plotbra('s-','pt50',fnr,5,'cl','b','lab',35); 
plotbra('b+','pt20',fnr,4,'cl','r','lab',5,'lp',18); 
plotbra('b-','pt10',fnr,5,'cl','r','lab',5,'lp',8); 
plotbra('h+','pt30',fnr,4, 'cl','m','lab',20); 
plotbra('h-','pt30',fnr,5, 'cl','m','lab',20); 
text(2.2,2,'hom','Fontsize',16,'color','k');
axis([2 3.25 0.7 6.2]); 
xlabel('\lambda'); ylabel('max/min(u_1)'); 
%% plot sol. incl. Fourier
p=loadp('b-','pt5'); plotsol(p); fouplot(p,10,1,[5 4],'b-/pt5'); pause
p=loadp('b+','pt5'); plotsol(p); fouplot(p,10,1,[5 4],'b+/pt5'); pause
p=loadp('h-','pt20'); plotsol(p); fouplot(p,10,1,[5 4],'h-/pt20'); pause
p=loadp('h+','pt20'); plotsol(p); fouplot(p,10,1,[5 4],'h+/pt20'); pause
plotsol('s+','pt35',1,1,2); pause; plotsol('s-','pt35',1,1,2); 
%% Hopf movie plot
p=loadp('ho1','pt20'); homovplot(p,1,1,2); 
%%
figure(5); clf; 
plotbra('ho1','pt20',5,6, 'cl','g'); 