% command templates for Schnakenberg on 4x1 domain, with snaking
clear all; p=[]; spx=4; spy=1; nx=30; % 1 spot in x and 1 spot in y direction 
par=[sqrt(60)*sqrt(3-sqrt(8))+0.1, 0, 60]; p=ooschnakinit(p,[spx,spy],nx,par); 
p.sw.para=2; p.nc.dsmax=0.1; p.sol.ds=-0.1; p.nc.resfac=1e-3; p.nc.neig=30; p.pm.mst=4; 
p.nc.nsteps=50; p=setfn(p,'bhom'); p.fuha.outfu=@schnakbra; p.sw.bifcheck=2; p=cont(p,30);
%% h+
p=mswibra('bhom','bpt1','bh+',0.01); p=taugen(p,[1 -1 0 0]); 
p=pmcont(p,1); p.pm.resfac=1e-4;  p.nc.dsmax=0.1; p=pmcont(p,10); 
p.sol.ds=0.1*sign(p.sol.ds); p.nc.dsmin=0.1; p.sw.bifcheck=1; p=pmcont(p,30); 
%% s+ 
p=mswibra('bhom','bpt1','bs+',-0.01);  
p=taugen(p,[0 1 0 0]); p.nc.dsmax=0.1; p=pmcont(p,50);
%% b+ 
p=swibra('bs+','bpt6','bb+',-0.05); p.nc.dsmin=0.05; p=pmcont(p,25);
%% snakes 
ds=0.025; p=swibra('bb+','bpt3','sn1',ds); p.nc.dsmin=ds; p.nc.dsmax=ds;  
p.sw.bifcheck=0; p=pmcont(p,50);
%% plot BD 
fnr=3; figure(fnr); clf; cmp=6; 
plotbraf('bhom','bpt2',fnr,cmp,'cl','k');
plotbra('bs+','pt40',fnr,cmp,'cl','b'); 
plotbra('bh+','pt30',fnr,cmp, 'cl','m'); 
plotbra('bb+','pt25',fnr,cmp,'cl','r','lab',[10]); 
plotbra('sn1','pt50',fnr,cmp, 'cl','k','lab',[25 35]); 
%text(2.5,4,'h+','Fontsize',16,'color','m');
%text(2.5,3.45,'s+','Fontsize',16,'color','b');
%text(2.5,3.8,'b+','Fontsize',16,'color','g');
axis([2.4 3.25 3.18 4.2]); 
xlabel('\lambda'); ylabel('||u||_8'); 
%% plot sol.  
plotsol('bh+','pt20',1,1,2); pause; plotsol('bs+','pt25',1,1,2); pause; 
plotsol('bb+','pt10',1,1,2); pause; plotsol('bb+','pt20',1,1,2); pause; 
plotsol('sn1','pt25',1,1,2); pause; plotsol('sn1','pt35',1,1,2); 
%%
p=loadp('sn1','pt25'); plotsol(p); colormap hot; fouplot(p,10,1,[20,3],'sn1/pt25'); pause
p=loadp('sn1','pt35'); plotsol(p); colormap hot; fouplot(p,10,1,[20,3],'sn1/pt35'); 
%%
p=loadp('bb+','pt10'); plotsol(p); colormap hot; fouplot(p,10,1,[20,3],'bb+/pt10'); 