%% demo traveling breather, C1: clear and init 
close all; format compact; keep pphome; 
p=[]; al=0.1125; bet=1.005; ga=6; del=0.003; D=3.5; s=0; par=[al bet ga del D s]; 
%lx=80; pw=0.5*lx; nx=round(1.2*lx); p=brinit(p,lx,nx,par,pw); plotsol(p); 
lx=50; pw=0.25*lx; nx=round(1*lx); p=brinit(p,lx,nx,par,pw); plotsol(p); 
x=getpte(p); x=x'; u=1./cosh(0.1*x); v=u;  %u=0.5*(1-tanh(x)); v=u; 
p.u0=[u;v]; p.u0x=p.Dx*p.u0;  % new u0 and u0x
%% C2: converge to TW (here standing pulse) via freezing
nt=1e4; pmod=250; vmod=100; dt=0.2; vel=[];  t1=0; 
[p,t1,vel]=tintfreeze(p,t1,dt,nt,pmod,vel,vmod); p0=p; 
%% C3: gradually decrease del=par(4) to first find breather at delta approx 0.0017, 
% which becomes unstable near del=0.0015, Bif seems subcritical! 
%p.u(p.nu+4)=p.u(p.nu+4)+0.0005; p.u(p.nu+4), t1=0; vel=[]; 
dt=0.5; 
 vel=[]; [p,t1,vel]=tintfreeze(p,t1,dt,nt,pmod,vel,vmod);
figure(7); clf; h=plot(vel(1,:),vel(2,:)); axis tight; p0=p; 
%% C4: set up and continue extended stat system; 
p=p0; p=setfn(p,'s3'); p.u0=p.u(1:p.nu); p.u0x=p.Dx*p.u0; % reset reference profile 
%p.mat.M=[[p.mat.M(1:p.nu,1:p.nu) zeros(p.nu,p.nc.nq)]; [zeros(p.nc.nq,p.nu) 0*speye(p.nc.nq)]];
p.nc.neig=10; p.nc.dsmax=0.04; p.sw.spcalc=1; p.u(p.nu+6)=vel(2,end); 
p.nc.nq=1; p.fuha.qf=@qf; p.fuha.qfder=@qfder; p.sw.qjac=1; % switch on constraints
p.nc.ilam=[4 6]; % set active pars to delta and s 
figure(2); clf; p.sol.ds=-1e-4; p.nc.dsmax=1e-2; p.nc.lammin=0; 
r=resi(p,p.u); norm(r(1:end-1),'inf'), r(end)
%%
p=cont(p,10); % continue 
%% C5: swibra to Hopf 
%huclean(p); 
aux.nqh=1; aux.nqnew=0; aux.dlam=0; imax=5; aux.qw=0.1; aux.qfac=1;
aux.tw=1e-3; % small weight of T in arclength useful here 
%aux.tl=20; ds=0.05; indir='s1'; dir='h1a'; aux.xif=100; 
%aux.tl=30; ds=0.25; indir='s1'; dir='h1b'; aux.xif=1000; % lx=50, nx=80; nice 
aux.tl=30; ds=0.025; indir='s3'; dir='h4'; aux.xif=100;   % wohl 'best' 
aux.tl=20; ds=0.05; indir='s3'; dir='h5'; aux.xif=100;   % wohl 'best' 
aux.tl=25; ds=0.05; indir='s3'; dir='h6'; aux.xif=100;   % wohl 'best' 
aux.tl=40; ds=0.05; indir='s3'; dir='h7'; aux.xif=100;   % wohl 'best' 
aux.tl=60; ds=0.05; indir='s3'; dir='h8'; aux.xif=100;   % wohl 'best' 
aux.qfh=@qfh; aux.qfhder=@qfhjac; 
p=hoswibra(indir,'hpt1',ds,4,dir,aux); p.hopf.flcheck=1; p.hopf.fltol=1e-2;
p.u0=p.u(1:p.nu); p.u0x=p.Dx*p.u0; 
p.hopf.auxp=@speedplot; % on the fly plot of s(t) 
p.nc.ilam=4; p.hopf.ilam=6; p.file.smod=1; p.nc.dsmax=4*ds; 
p.fsol.opt.TolX=1e-12; 
%% C6: continue per. orbit for 1 steps with fsolve, then switch to Newton 
p.fsol.fsol=1; p.fsol.tol=1e-10; p.fsol.imax=imax; p.nc.tol=1; % tol really in fsol.tol 
huclean(p); p.sw.verb=2; p.hopf.jac=1; p=cont(p,20); 
%%
p.fsol.fsol=0; p.nc.tol=1e-3; p=cont(p,2); %p.nc.tol=1e-6; p=cont(p,20); 
%% C7: Floquet checks
[muv1,muv2,ind,mo,h]=floqap('h1','pt5'); 
%% C8: branch plotting
bf=3; pcmp=8; figure(bf); clf; plotbra('s3','pt10',bf,pcmp,'cl','k','fp',5);
plotbra('h7','pt25',bf,pcmp,'cl','r','lab',[5,10,25]); ylabel('max(u_1)'); 
%%
bf=4; pcmp=7; figure(bf); clf;
plotbra('h1','pt25',bf,pcmp,'cl','r','lab',[5,10,25],'fp',1);  ylabel('period T');
%% soln plots
dir='h1'; pt='pt'; ind=[5 10 21 30]; 
for i=1:length(ind);
    q=loadp(dir, [pt mat2str(ind(i))]); 
    hoplot(q, 1,1,1); figure(1); view(10,70);  
    title(['u_1 at ' dir '/' [pt mat2str(ind(i))]]); axis tight;
    set(gca,'ZTick',[0 0.4 0.8]); pause
end 