% adapted from tints to freeze the translation symmetry
function [p,t1,vel]=tintfreeze(p,t0,dt,nt,pmod,vel,vmod)
n=0; t=t0; np=p.np; par=p.u(p.nu+1:end); 
D=par(5); K=p.mat.K; Kx=p.mat.Kx; 
bK=[[K 0*K];[0*K D*K]]; 
while(n<nt) % integration loop
  f=nodalf(p,p.u); t=t+dt; 
  g=p.mat.M*p.u(1:p.nu)+dt*p.mat.M*f; 
  r=bK*p.u(1:p.nu)-p.mat.M*f; 
  ux=Kx*p.u(1:p.nu); va=(ux'*r)/(ux'*ux); 
  if (mod(n,vmod)==0);  vel=[vel [t; va]]; end 
  % time stepping:
  Lam=p.mat.M+dt*(bK-va*Kx); 
  [L,U,P,Q,R]=lu(Lam);
  p.u(1:p.nu)=Q*(U\(L\(P*(R\g)))); n=n+1; 
  if(mod(n,pmod)==0); plotsol(p,p.plot.ifig,p.plot.pcmp,p.plot.pstyle); end
end 
t1=t; 